// GeoGet 2
// GPX route
// Autor: Sobikovi
// Verze: 1.0.0
//
// Makro exportuje vechny kee v seznamu dle poadi v seznamu
// Pokud m ke definovan final souadnice, exportuj se final souadnice msto vchozch
// Final souadnice maj ped nzvem kee F-
// Pokud m ke definovan parking waypoit a je nastaveno Parking na Ano, exportuje se jako prvn tak parking waypoint
// Parking souadnice maj ped nzvem kee P-
//
// ToDo:
// Monost nastavit jmno trasy, zatm default Trasa GeoGet
// Volba kter parking waypoint se m exportovat. Nyn se exportuj vechny

{$INCLUDE gpxroute.config.pas}

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'GPX route';
end;

function ExportHeader: string;
begin
// Hlavika pevzat z Oregona 550 s drobnou pravou
Result := '<?xml version="1.0" encoding="UTF-8" standalone="no" ?><gpx xmlns="http://www.topografix.com/GPX/1/1" xmlns:gpxx="http://www.garmin.com/xmlschemas/WaypointExtension/v1" xmlns:gpxtrx="http://www.garmin.com/xmlschemas/GpxExtensions/v3" xmlns:gpxtpx="http://www.garmin.com/xmlschemas/TrackPointExtension/v1" creator="GeoGet" version="1.1" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd http://www.garmin.com/xmlschemas/WaypointExtension/v1 http://www8.garmin.com/xmlschemas/WaypointExtensionv1.xsd http://www.garmin.com/xmlschemas/TrackPointExtension/v1 http://www.garmin.com/xmlschemas/TrackPointExtensionv1.xsd"><metadata><link href="http://www.garmin.com"><text>Garmin International</text></link><time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time></metadata><rte><name>Trasa GeoGet</name>';
end;

function ExportFooter: string;
begin
  result := '</rte></gpx>' + CRLF;
end;

function ExportPoint: string;
var
 Text: string;
 m: integer;

begin
 
  If Parking = 'Ano' then
  Begin // parking
  If GC.Waypoints.Count > 0 then  // ke m njak waypointy
	Begin
		m := 0;
		for m := 0 to GC.Waypoints.Count - 1 do
			// if GC.Waypoints[m].IsListed then
			if GC.Waypoints[m].WptType = 'Parking Area' then
			Begin
				Text := '<rtept lat="' + GC.Waypoints[m].Lat + '" lon="' + GC.Waypoints[m].Lon + '"><name>P-' + UtfToAscii(GC.Waypoints[m].ParentName) + '</name></rtept>';
				Result := Result + Text;
			end // parking
    end; // if	
  end; // parking
  
  if GC.HaveFinal then  // mme final, exportujeme final
    begin
		Text := '<rtept lat="' + GC.CorrectedLat + '" lon="' + GC.CorrectedLon + '"><name>F-' + GC.name + '</name></rtept>';
		Result := Result + Text;
    end else     // nemme final, exportujeme original
    begin
// <rtept lat="GC.Lat" lon="GC.Lon"><name>GC.name</name></rtept>
		Text := '<rtept lat="' + GC.Lat + '" lon="' + GC.Lon + '"><name>' + GC.name + '</name></rtept>';
		Result := Result + Text;
    end;
end;